function strStageInfo = BuildCircuit_StageInformation(curStage,strStageInfo)
% BuildCircuit_StageInformation is a subfile of the AnalogFilter GUI collection
%
% BuildCircuit_StageInformation ??????????????????

% James C. Squire, Assistant Professor, Virginia Military Institute
% ver 1.0

% strStageInfo must define: 
% bComponentsExact bFrequencyIsRad bGainIsLinear fCustomFrequency
% bSensitivityInC (either R or C) 
% bSensitivityInChoose (either Choose or Calc) 
% bSensitivityInNumber (the number of R/C Choose/Calc)
% nSensitivityOut (where 1 = abs(z), 2 = abs(p), 3 = k, 4 = Q, 5 = wo, 6 = wz)

% setup
if strStageInfo.bComponentsExact
    z = curStage.z;
    p = curStage.p;
    k = curStage.k;
else
    z = curStage.z1;
    p = curStage.p1;
    k = curStage.k1;
end
zr = real(z);
zi = imag(z);
pr = real(p);
pi = imag(p);

