function MenuFileSaveAs(handles)
% MenuFileSaveAs is a subfile of the AnalogFilter GUI collection
%
% James C. Squire, 2002
% Assistant Professor, Virginia Military Institute
% ver 1.0

% MenuFileSaveAs saves a global strFilterObject as a new filename, 
% and updates the gui's FilterObject

global strFilterObject

[sFileName, sPathName] = uiputfile('*.flt','Save As Analog Filter File'); 

% if cancel not pressed
if sFileName
    if isempty(findstr(sFileName,'.flt')) 
        sFileName = [sFileName '.flt']; 
    end
    strFilterObject.sFileName = sFileName;
    strFilterObject.sFigureName = ['Analog Filter Designer: ' sFileName];
    save([sPathName sFileName],'strFilterObject') %'strFilterObject','-MAT')
    
    % update the figure name and store that in the figure's data handles
    set(handles.figSpecifyFilter,'Name',strFilterObject.sFigureName)
end
