function SpecifyFilter_HelpContext
% SpecifyFilter_HelpContext is a subfile of the AnalogFilter GUI collection
%
% James C. Squire, 2002
% Assistant Professor, Virginia Military Institute
% ver 1.0

% SpecifyFilter_HelpContext provides simple help information

% create help text
text{1} = 'Overview: Define a filter, then use the menu to analyze or build it.';
text{2} = ' ';
text{3} = 'Filter Purpose';
text{4} = 'Although only low or highpass filters may be designed, they may be concatenated to build bandpass and bandstop filters.';
text{5} = ' ';
text{6} = 'Filter Type';
text{7} = 'Bessel filters have the worst frequency-domain characteristics (gradual cutoff), but excellent time-domain characteristics (near zero step response overshoot, keeps signal shape intact).';
text{8} = 'Butterworth filters have monotonic frequency-domain characteristics, like the Bessel, but with a sharper frequency cutoff.  Their step response shows greater overshoot.';
text{9} = 'Chebychev filters have sharper cutoffs than the Butterworth at the expense of ripple in the passband (I) or stopband (II), and have a larger step response overshoot.';
text{10} = 'Elliptic filters have the sharpest cutoff but the worst time domain characteristics (highest step overshoot, greatest signal shape distortion).';
text{11} = ' ';
text{12} = 'Parameter Definitions Figure';
text{13} = 'The plot shows the definitions for fc, Gp, and Gs for the various filter types and orders (e.g. the effect of odd/even order on asymptotic gain), but is inaccurate (e.g. number of ripples likely incorrect).  Use the menu for an accurate frequency response.';
text{14} = ' ';
text{15} = 'See the printed documentation for more details.';

% create help popup window
msgbox(text,'Help: Specify Filter','none')
